hdu 1024 Max Sum Plus Plus (dp+二维变一维)

来源:互联网 发布:苹果mac改变用户 编辑:程序博客网 时间:2024/06/05 08:02

Max Sum Plus Plus

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 13722    Accepted Submission(s): 4522


Problem Description
Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

Given a consecutive number sequence S1, S2, S3, S4 ... Sx, ... Sn (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ Sx ≤ 32767). We define a function sum(i, j) = Si + ... + Sj (1 ≤ i ≤ j ≤ n).

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i1, j1) + sum(i2, j2) + sum(i3, j3) + ... + sum(im, jm) maximal (ix ≤ iy ≤ jx or ix ≤ jy ≤ jx is not allowed).

But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(ix, jx)(1 ≤ x ≤ m) instead. ^_^
 

Input
Each test case will begin with two integers m and n, followed by n integers S1, S2, S3 ... Sn.
Process to the end of file.
 

Output
Output the maximal summation described above in one line.
 

Sample Input
1 3 1 2 32 6 -1 4 -2 3 -2 3
 

Sample Output
68
Hint
Huge input, scanf and dynamic programming is recommended.
 

思路:
dp。
状态:dp[i][j]-最大和    i-已经组成多少组  j-已经用掉多少数。
方程:dp[i][j]=max(dp[i-1][j]+s[i],dp[k][j-1]+s[i]);   (j>=i)  (0<k<i)
时间复杂度为O(n*m^2),dp[k][j-1]可以递推时用一个值维护,降到O(n*m).
由于n比较大,空间吃不消,所以要优化空间。
考虑到第一维每次都是从i-1到i,故可以将第一维去掉。
方程变为 dp[j]=max(dp[j-1]+s[j],ma[j-1]+s[j]);

代码:
#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#define maxn 1000005#define INF 0x3f3f3f3fusing namespace std;typedef long long ll;ll n,m,ans;ll s[maxn],ma[maxn];ll dp[maxn];void solve(){    int i,j;    ll t;    ma[0]=dp[0]=0;    for(i=1;i<=m;i++)    {        t=-INF;        for(j=i;j<=n;j++)        {            dp[j]=max(dp[j-1]+s[j],ma[j-1]+s[j]);            ma[j-1]=t;            t=max(t,dp[j]);        }        ma[n]=t;    }}int main(){    int i,j;    while(~scanf("%I64d%I64d",&m,&n))    {        for(i=1;i<=n;i++)        {            scanf("%I64d",&s[i]);            ma[i]=0;        }        solve();        printf("%I64d\n",ma[n]);    }    return 0;}/*1 31 2 32 6-1 4 -2 3 -2 32 6-1 -2 -3 -4 -5 -6*/







原创粉丝点击